import soulbot
from soulbot import SoulBot


class Misc:
    
    __bin = (   (0,0,0), (0,0,1), (0,1,0), (0,1,1),
                (1,0,0), (1,0,1), (1,1,0), (1,1,1)
            )

    __cob = (   0, 4, 2, 6, 1, 5, 3, 7 )
    
    def __init__(self, iss, oss, mg):
        self.__iss = iss
        self.__oss = oss
        self.__mg = mg

        self.__nReq = 0
        self.__nAck = 0

        self.status = { "LED":0, "OSC":[0,0], "SPK":[0, 0] }


    def speaker(self, v, pre):
        op = self.__mg["SPK"]

        self.__oss(op.genOp(v, pre))
        self.__nReq += 1
        r = SoulBot.checkResponse(op, self.__iss)
        self.__nAck += 1

        if r:
            self.status["SPK"][0] = v
            self.status["SPK"][1] = pre

        return r


    def scLeds(self, smsk, cmsk):
        op = self.__mg["LED"]

        smsk &= 0x3F
        cmsk &= 0x3F
        s = ( Misc.__cob[smsk >> 3] | (Misc.__cob[smsk & 0x7] << 3) )
        c = ( Misc.__cob[cmsk >> 3] | (Misc.__cob[cmsk & 0x7] << 3) )
        
        self.__oss(op.genOp(s, c))
        self.__nReq += 1
        r = SoulBot.checkResponse(op, self.__iss)
        self.__nAck += 1

        if r:
            self.status["LED"] = smsk & (~cmsk)
            self.status["OSC"][0] &= ~(smsk | cmsk)
        
        return r
        
    def touch(self, msk):
        return self.scLeds(msk | self.status["LED"], 0)

    def untouch(self, msk):
        return self.scLeds(self.status["LED"], msk)

    def oscLeds(self, omsk, pre):
        op = self.__mg["OSC"]

        omsk &= 0x3F
        o = ( Misc.__cob[omsk >> 3] | (Misc.__cob[omsk & 0x7] << 3) )
        
        self.__oss(op.genOp(o, pre))
        self.__nReq += 1
        r = SoulBot.checkResponse(op, self.__iss)
        self.__nAck += 1

        if r:
            self.status["OSC"][0] |= omsk
            self.status["OSC"][1] = pre
            self.status["LED"] &= (~omsk)
            
        return r

    
    def led(self):
        l = self.status["LED"]
        return (Misc.__bin[l >> 3] + Misc.__bin[l & 0x7])

    def osc(self):
        o = self.status["OSC"][0]
        return (Misc.__bin[o >> 3] + Misc.__bin[o & 0x7])
    

    def nReq(self):
        return self.__nReq

    def nAck(self):
        return self.__nAck


    def clear(self):
        self.status["LED"] = 0
        
        self.status["OSC"][0] = 0
        self.status["OSC"][1] = 0
        
        self.status["SPK"][0] = 0
        self.status["SPK"][1] = 0

        
