from soulbot import SoulBot

class Sensor:
    __slots__ = ['__sg','__iss','__oss', 'status', '__nReq', '__nAck', '__nstep']
    
    def __init__(self, iss, oss, sg):
        self.__sg = sg
        self.__iss = iss
        self.__oss = oss

        kv = sg.items()
        self.status = dict([ (v[0], [] ) for v in kv ])
        self.__nstep = dict(( (v[0], 4 ) for v in kv ))

        self.__nReq = 0
        self.__nAck = 0

    def __getitem__(self, key):
        op = self.__sg[key]
        self.__oss(op.genOp())
        self.__nReq += 1
        r = SoulBot.checkResponse(op, self.__iss)
        self.__nAck += 1
        if r:
            last = self.__nstep[key]
            v = tuple([ ord(r[i]) for i in xrange(op.getNumRet()) ])
            self.status[key].insert(0,v)
            if len(self.status[key]) == (last + 1):
                del self.status[key][last]
            return v
        else: return False

    def get(self, key):
        return self[key]

    def listSensorOp(self):
        return self.status.keys()

    def nReq(self):
        return self.__nReq

    def nAck(self):
        return self.__nAck

    def setStepMem(self, k, n):
        if n < 1: return False
        else:
            self.status[k] = self.status[k][0:n]
            self.__nstep[k] = n
            return True

    def clear(self):
        for (k,v) in self.status.items():
            del self.status[k][:]
            self.__nstep[k] = 4
        
            
        
        
        

    
