import uabot
import time

##if __name__=="__main__":
##    #ua.motor.rotate(0.1)
##    for i in xrange(64): print ua.sensor["LFW"][0]
##    ua.motor.stop()

def tracking(ua, vel, off):    
    up(ua, vel, off)
    ua.motor.forward(vel)
    while ua.sensor["LFW"][0] == 0: continue

    ua.motor.rotate(vel)
    if ua.sensor["LFW"][0] & 0x8: 
        while ua.sensor["LFW"][0] & 0x8: continue
        while not ua.sensor["LFW"][0] & 0x8: continue
    elif ua.sensor["LFW"][0] & 0x1: 
        while ua.sensor["LFW"][0] & 0x1: continue
        while not ua.sensor["LFW"][0] & 0x1: continue

    ua.motor.stop()


def tright(ua, vel, off):
    v = 0
    up(ua, vel, off)

    ua.motor.backward(vel)
    while ua.sensor["LFW"][0] != 0: continue
    
    ua.motor.pvr(vel)
    while ua.sensor["LFW"][0] != 15: continue

    ua.motor.backward(vel)
    while ua.sensor["LFW"][0] & 0x1: continue    
    while not ua.sensor["LFW"][0] & 0x1: continue

    ua.motor.pvr(vel)
    while ua.sensor["LFW"][0]: continue

    ua.motor.forward(vel)
    while not ua.sensor["LFW"][0]: continue
        
    ua.motor.stop()


def tr(ua, vel, off):
    v = 0
    up(ua, vel, 0.3)

    ua.motor.backward(vel)
    while ua.sensor["LFW"][0] != 0: continue
    
    ua.motor.pvr(vel)
    while ua.sensor["LFW"][0] != 15: continue

    ua.motor.pvl(-vel)
    while ua.sensor["LFW"][0]: continue
    while not ua.sensor["LFW"][0] & 0x12 : continue

    ua.motor.forward(vel)
    while ua.sensor["LFW"][0]: continue
    while not ua.sensor["LFW"][0]: continue

    ua.motor.move(vel + 0.3, vel)
    while ua.sensor["LFW"][0] != 9: continue 
    ua.motor.rotate(-1, 0.05)
    
    ua.motor.stop()

    
    
def upp(ua, vel, off):
    n = 8
    
    loff = { 3:0.6, 7:1 }
    roff = { 12:0.6, 14:1 }

    while True:
        v = ua.sensor["LFW"][0]

        if v in [3, 7]: ua.motor.move(vel, vel + loff[v]*off)
        elif v in [12, 14]: ua.motor.move(vel + roff[v]*off, vel)
        elif v in [0, 15]:
            print "Cross"
            ua.motor.stop()
            break
        elif v in [13, 9, 11]:
            ua.motor.forward(vel)


def center(ua):

    ua.motor.forward(0.1)
    while ua.sensor["LFW"][0] == 0: continue

    ua.motor.stop()
    if ua.sensor["LFW"][0] == 14:
        ua.motor.pvr(0.1)
        while ua.sensor["LFW"][0] == 14: continue

        ua.motor.forward(0.1)
        while ua.sensor["LFW"][0] == 12: continue

        ua.motor.pvl(0.1)
        while ua.sensor["LFW"][0] != 11: continue 

    elif ua.sensor["LFW"][0] == 7:
        ua.motor.pvl(0.1)
        while ua.sensor["LFW"][0] == 7: continue

        ua.motor.forward(0.1)
        while ua.sensor["LFW"][0] == 3: continue

        ua.motor.pvr(0.1)
        while ua.sensor["LFW"][0] != 13: continue

    ua.motor.stop()
    

def senTest(ua, s, n=128, display=True):
    print "Starting " + s + " Test at " + time.ctime() + \
          "\n%i samples are becoming. Sampling..." % (n)
    t = time.clock()

    for i in xrange(n):
        v = ua.sensor[s]
        if display: print v

    t = time.clock() - t
    print "\nElapse time: %.6f sec,\n%s Rate: %.6f sample/sec" % (t, s, n/t)
    
    
def micTest(ua, n=128, m=32, tol=10):
    print   "Starting Microphone Test at " + time.ctime() + \
            "\n%i samples are becoming. Sampling..." % (n)
    t = time.clock()

    for i in xrange(n):
        v = ua.sensor["MIC"][0]
        if v > m + tol: print "HIGH TOC TOC"
        elif v < m - tol: print "LOW TOC TOC"

    t = time.clock() - t
    print "\nElapse time: %.6f sec,\nRate: %.6f sample/sec" % (t, n/t)


    
