import sys
import op

class UABOTException(Exception):
    def __init__(self, err=0, msg=""):
        self.err = 0
        self.msg = msg
        
    def __str__(self):
        return repr(self.msg)


class UABOTExceptionTimeout(UABOTException):
    def __init__(self, msg="Timeout"):
        UABOTException.__init__(self, 1, msg)

class UABOTExceptionConnect(UABOTException):
    def __init__(self, msg="Not Connected"):
        UABOTException.__init__(self, 2, msg)

class UABOTExceptionErrorOp(UABOTException):
    def __init__(self, opExp, msg="Operation failed"):
        msg += (" <Opcode: 0x%02x>" % opExp )
        UABOTException.__init__(self, 3, msg)
        self.op = op

class UABOTExceptionFrame(UABOTException):
    def __init__(self, msg="Bad frame received"):
        UABOTException.__init__(self, 4, msg)
